MailTotal = {}
 
MailTotal.name = "MailTotal"

function MailTotal:RefreshCount (...)
    local unread_total = CHAT_SYSTEM.numUnreadMails
    local total = 0

    if MAIL_INBOX.masterList == nil then
        for i in ZO_GetNextMailIdIter do
            total = total + 1
        end
        total = total + unread_total
    else
        local read = 0
        local unread = 0

        for k, v in pairs(MAIL_INBOX.masterList) do
            if v.unread == true then
                unread = unread + 1
            else
                read = read + 1
            end
        end

        if unread ~= unread_total then
            total = read + unread_total
        else
            total = read + unread
        end
    end

    CHAT_SYSTEM.mailLabel:SetText(unread_total .. "/" .. total)
end

function MailTotal:Initialize()
    local zo = CHAT_SYSTEM.OnNumUnreadMailChanged
    CHAT_SYSTEM.OnNumUnreadMailChanged = function (...)
        zo(...)

        MailTotal:RefreshCount()
    end

    MailTotal:RefreshCount()
end
 
function MailTotal.OnAddOnLoaded(event, addonName)
    if addonName == MailTotal.name then
        MailTotal:Initialize()
    end
end
 
EVENT_MANAGER:RegisterForEvent(MailTotal.name, EVENT_ADD_ON_LOADED, MailTotal.OnAddOnLoaded)
EVENT_MANAGER:RegisterForEvent(MailTotal.name, EVENT_MAIL_OPEN_MAILBOX, MailTotal.RefreshCount)
EVENT_MANAGER:RegisterForEvent(MailTotal.name, EVENT_MAIL_INBOX_UPDATE, MailTotal.RefreshCount)
EVENT_MANAGER:RegisterForEvent(MailTotal.name, EVENT_MAIL_REMOVED, MailTotal.RefreshCount)
